%name ObjGrammar
%header{
#include <iostream>
using std::cout;
using std::endl;
%}

%union {
		int itype;
		double dtype;
		char *stype;
	}

%token <itype> INTEGER
%token <dtype> FLOAT
%token <stype> GROUP USEMTL
%token <void> VERTEX TEXCOORD NORMAL FACE SMOOTH ENDL SLASH

%type <dtype> value
%type <void> smooth file line lines command vertex texcord normal face vrefs vref group usemtl
%start file

/* -------------- rules section -------------- */
/* Sample parser. Does count Chars in a line, and lines in file */
%%
file    : lines
                ;

lines   : lines line
                | line
                ;

line    : command ENDL
                | ENDL
                ;

command : vertex | texcord | normal | face | smooth | group | usemtl
                ;

vertex  : VERTEX value value value { act->AddVertex($2, $3, $4); }
                ;

texcord : TEXCOORD value value { act->AddTexcoord($2,$3); }
                | TEXCOORD value value value { act->AddTexcoord($2,$3,$4); }
                ;

normal  : NORMAL value value value { cout << "Normal: " << $2 << ',' << $3 << ',' << $4 << endl; }
                ;

face    : FACE vref vref vref vrefs
                ;

vrefs   : vrefs vref
                |
                ;

vref    : INTEGER
                | INTEGER SLASH INTEGER
                | INTEGER SLASH INTEGER SLASH INTEGER
                | INTEGER SLASH SLASH INTEGER
                ;

smooth  : SMOOTH INTEGER { cout << "Smoothgroup: " << $2 << endl; }
                ;

group   : GROUP { cout << "Group: \"" << $1 << "\"" << endl; free($1); }
                ;

usemtl  : USEMTL { cout << "UseMtl: \"" << $1 << "\"" << endl; free($1); }
                ;

value   : INTEGER { $$ = $1; }
                | FLOAT
                ;

%%
/* -------------- body section -------------- */
